from __future__ import annotations
from typing import Tuple

from .analysis import Analysis
from lang.cfg import Entry, Exit, InnerNode, Node
from lang.ast import Assignment, Guard, Variable
from lang import getStatementUsedVars

AnalysisType = ...

class LiveVariables(Analysis[AnalysisType]):
    def initial_in(self, node: Node) -> AnalysisType:
        return ...

    def initial_out(self, node: Node) -> AnalysisType:
        return ...

    def get_new_values(self, node: Node, predecessors_out: list[AnalysisType], successors_in: list[AnalysisType]) -> Tuple[AnalysisType, AnalysisType]:

        """ 
        Return tuple (In, Out), computed using this node's predessors' Outs (`predecessors_out`) and/or 
        its succesors' Ins (`successors_in`). 
        """

        Gen = ...
        Kill = ...

        # Update Gen and Kill, depending on Node type 
        if isinstance(node, Entry):
            ...
        elif isinstance(node, Exit):
            ...
        elif isinstance(node, InnerNode):
            if isinstance(node.statement, Guard):
                ...
            elif isinstance(node.statement, Assignment):
                ...
            else: 
                raise Exception(
                f"InnerNode {node} with statement of type {type(node.statement)} not supported in {type(self).__name__}'s get_new_values method.")
        else:
            raise Exception(
                f"Node {node} of type {type(node)} not supported in {type(self).__name__}'s get_new_values method.")
        
        Out = ...
        In = ...

        return (In, Out)


